﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Tab_C1DataGrid
{
    public partial class MainWindow : Window
    {
        DataTable dt;
        public MainWindow()
        {
            InitializeComponent();
             dt= new DataTable();
            dt.Columns.Add("CustomerID", typeof(int));
            dt.Columns.Add("ContactName", typeof(string));
            dt.Columns.Add("Designation", typeof(string));
            dt.Columns.Add("Country", typeof(string));

            //Sample Data
            dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain");
            dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico");
            dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
            dt.Rows.Add(4, "Thomas Hardy", "Sales Representative", "UK");
            dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany");
            dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain");
            dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico");
            dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK");
            dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
            dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
            dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
            dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator", "Brazil");
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            _grid.ItemsSource = dt.DefaultView;
            _grid.IsTabStop = true;
        }

        private void _grid_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab)
            {
                e.Handled = true;
                int row=0;
                int col=0;
                if (_grid.Selection.SelectedCells.Count > 0)
                {
                    row = _grid.Selection.SelectedCells[0].Row.Index;
                    col = _grid.Selection.SelectedCells[0].Column.Index;
                }
                _grid.Selection.Clear();
                if (col < _grid.Columns.Count - 1)
                {
                    _grid.Selection.Add(_grid[row, col + 1]);
                }
                else if (row == _grid.Rows.Count - 1 && col == _grid.Columns.Count - 1)
                {
                    _grid.MoveFocus(new TraversalRequest(FocusNavigationDirection.Next));
                }
                else
                {
                    _grid.Selection.Add(_grid[row + 1, 0]);
                }
                if(_grid.Selection.SelectedCells.Count>0)
                _grid.CurrentCell = _grid.Selection.SelectedCells[0];
            }
        }
        private void _grid_Loaded(object sender, RoutedEventArgs e)
        {
            _grid.Selection.Add(_grid[0, 0]);
        }
    }
}
